"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var BasicRouter_1 = require("../BasicRouter");
var CsomRouter = (function (_super) {
    __extends(CsomRouter, _super);
    function CsomRouter(context, settings) {
        var _this = _super.call(this, context, settings) || this;
        _this.router = function (req, res, _next) {
            _this.spr = _this.getHttpClient();
            var endpointUrl = _this.util.buildEndpointUrl(req);
            _this.logger.info('\nPOST (CSOM): ' + endpointUrl);
            var agent = _this.util.isUrlHttps(endpointUrl) ? _this.settings.agent : undefined;
            var body = '';
            req.on('data', function (chunk) { return body += chunk; });
            req.on('end', function () {
                Promise.all([
                    _this.spr.requestDigest((endpointUrl).split('/_vti_bin')[0]),
                    _this.util.getAuthOptions()
                ])
                    .then(function (_a) {
                    var digest = _a[0], opt = _a[1];
                    var headers = __assign(__assign({}, opt.headers), { 'Accept': '*/*', 'Content-Type': 'text/xml', 'X-Requested-With': 'XMLHttpRequest', 'X-RequestDigest': digest });
                    return _this.spr.post(endpointUrl, { headers: headers, body: body, agent: agent, json: false });
                })
                    .then(function (r) { return _this.transmitResponse(res, r); })
                    .catch(function (err) { return _this.transmitError(res, err); });
            });
        };
        return _this;
    }
    return CsomRouter;
}(BasicRouter_1.BasicRouter));
exports.CsomRouter = CsomRouter;
//# sourceMappingURL=csom.js.map