"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var BasicRouter_1 = require("../BasicRouter");
var SoapRouter = (function (_super) {
    __extends(SoapRouter, _super);
    function SoapRouter(context, settings) {
        var _this = _super.call(this, context, settings) || this;
        _this.router = function (req, res, _next) {
            _this.spr = _this.getHttpClient();
            var endpointUrl = _this.util.buildEndpointUrl(req);
            _this.logger.info('\nPOST (SOAP): ' + endpointUrl);
            var agent = _this.util.isUrlHttps(endpointUrl) ? _this.settings.agent : undefined;
            var body = '';
            req.on('data', function (chunk) { return body += chunk; });
            req.on('end', function () {
                if (req.headers.origin) {
                    var regExpOrigin = new RegExp(req.headers.origin, 'g');
                    body = body.replace(regExpOrigin, _this.ctx.siteUrl);
                }
                _this.util.getAuthOptions()
                    .then(function (opt) {
                    var headers = __assign(__assign({}, opt.headers), { 'SOAPAction': req.headers.soapaction, 'Accept': 'application/xml, text/xml, */*; q=0.01', 'Content-Type': 'text/xml;charset="UTF-8"', 'X-Requested-With': 'XMLHttpRequest' });
                    return _this.spr.post(endpointUrl, { headers: headers, body: body, agent: agent, json: false });
                })
                    .then(function (r) { return _this.transmitResponse(res, r); })
                    .catch(function (err) { return _this.transmitError(res, err); });
            });
        };
        return _this;
    }
    return SoapRouter;
}(BasicRouter_1.BasicRouter));
exports.SoapRouter = SoapRouter;
//# sourceMappingURL=soap.js.map