"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateGuid = function () {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0;
        var v = c === 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
};
exports.checkNestedProperties = function (object) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    args.forEach(function (arg) {
        if (!object || !object.hasOwnProperty(arg)) {
            return false;
        }
        object = object[arg];
    });
    return true;
};
exports.getCaseInsensitiveProp = function (object, propertyName) {
    propertyName = propertyName.toLowerCase();
    return Object.keys(object).reduce(function (res, prop) {
        if (prop.toLowerCase() === propertyName) {
            res = object[prop];
        }
        return res;
    }, undefined);
};
exports.trimMultiline = function (multiline) {
    return multiline.trim().split('\n').map(function (line) { return line.trim(); }).join('\n');
};
//# sourceMappingURL=misc.js.map