import * as spauth from 'node-sp-auth';
import * as spRequest from 'sp-request';
import { Request } from 'express';
import { IProxyContext, IProxySettings } from '../core/interfaces';
export declare class ProxyUtils {
    private ctx;
    private settings;
    private spr;
    constructor(ctx: IProxyContext, settings: IProxySettings);
    getAuthOptions(): Promise<spauth.IAuthResponse>;
    getCachedRequest(spr: spRequest.ISPRequest): spRequest.ISPRequest;
    isOnPrem(url: string): boolean;
    isUrlHttps(url: string): boolean;
    isUrlAbsolute(url: string): boolean;
    buildEndpointUrl(req: Request | string): string;
    buildProxyEndpointUrl(reqUrl: string): string;
}
